
import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.ibm.bpe.api.BusinessFlowManager;
import com.ibm.bpe.api.BusinessFlowManagerHome;
import com.ibm.bpe.api.BusinessProcess;
import com.ibm.bpe.api.ClientObjectWrapper;
import com.ibm.bpe.api.LocalBusinessFlowManager;
import com.ibm.bpe.api.LocalBusinessFlowManagerHome;
import com.ibm.bpe.api.ProcessTemplateData;
import com.ibm.bpe.api.ReplyContextWrapper;

import commonj.sdo.DataObject;

/*
 * Created on Jul 26, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Nikhil Penmetsa
 * Sarasu IT Solutions, Ltd
 * 
 * This is a sample java program to Start a process template in Business Process Choregrapher
 * Developed in WID
 * The Program starts a process called HelloWorld
 */
public class StartProcessTemplate {
	public void startProcess() throws NamingException, RemoteException,
			CreateException {
	
		// Setup the Initial Context
		InitialContext initialContext = new InitialContext();

		// Lookup the local home interface of the LocalBusinessFlowManager bean

		Object result = initialContext
				.lookup("com/ibm/bpe/api/BusinessFlowManagerHome");
		System.out.println("Lookup successful");
		BusinessFlowManagerHome processHome = (BusinessFlowManagerHome) javax.rmi.PortableRemoteObject
				.narrow(result, BusinessFlowManagerHome.class);
		System.out.println("Instantiated the BusinessFlowManagerHome");
		BusinessFlowManager process = processHome.create();

		System.out.println("Created the BusinessFlowManager from BusinessFlowManagerHome");
		try {
			System.out.println("Querying processes");
			//ProcessTemplateData[] processTemplates = process. queryProcessTemplates  ("PROCESS_TEMPLATE.EXECUTION_MODE = PROCESS_TEMPLATE.EXECUTION_MODE.EXCECUTION_MODE_MICROFLOW",  "PROCESS_TEMPLATE.NAME", new Integer(50), null);
			// This step is not needed if we now the process
			ProcessTemplateData[] processTemplates = process
					.queryProcessTemplates("", "PROCESS_TEMPLATE.NAME",
							new Integer(50), null);
			ProcessTemplateData template = processTemplates[0];
			System.out.println("Template name " + template.getDisplayName());
			//ClientObjectWrapper input = process.getInputMessage (template.getID());
			ClientObjectWrapper input = new ClientObjectWrapper(
					"Nikhil Penmetsa");

			System.out.println("ClientObjectWrapper Input Created");
			
			ReplyContextWrapper RC = new ReplyContextWrapper();

			//run the process
			//process.callWithReplyContext(template.getName(), input, RC);
			//ClientObjectWrapper output = process.call(template.getName(), input);
			ClientObjectWrapper output = process.call("HelloWorldProcess", input);
			System.out.println("Successfully instantiated the process Hello World");
			

		} catch (Exception e) {
			System.out.println("Exception : " + e);

		}

	}

}
